#pragma semicolon 1

#include <sourcemod>
#include <sdkhooks>
#include <vip>
#include <weaponfight>

public Plugin:myinfo = 
{
	name	= "VIP [Tears of Denial]",
	author	= "wS",
	version = "1.0.4"
};

#define ITEM_NAME "tears_of_denial"
new bool:g_bAccess[MAXPLAYERS + 1];

new bool:g_bUsed[MAXPLAYERS + 1];
new bool:g_bDmgSelf, bool:g_bDmgPlayerOnly;
new bool:mp_friendlyfire_on;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	LoadTranslations("vip_modules_description.phrases");
	
	//
	decl Handle:hCvar;
	
	hCvar = CreateConVar("tod_dmg_self", "1");
	g_bDmgSelf = GetConVarInt(hCvar) == 1;
	HookConVarChange(hCvar, CvarChanged);
	
	hCvar = CreateConVar("tod_dmg_playeronly", "1");
	g_bDmgPlayerOnly = GetConVarInt(hCvar) == 1;
	HookConVarChange(hCvar, CvarChanged);
	
	if ((hCvar = FindConVar("mp_friendlyfire")))
	{
		mp_friendlyfire_on = GetConVarInt(hCvar) != 0;
		HookConVarChange(hCvar, CvarChanged);
	}
	
	AutoExecConfig(true, ITEM_NAME, "vip/modules/tears_of_denial");
	//
	
	HookEvent("player_spawn", player_spawn, EventHookMode_Post);
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	decl String:CvarName[32];
	GetConVarName(hCvar, CvarName, sizeof(CvarName));
	if (!strcmp(CvarName, "tod_dmg_self", false)) g_bDmgSelf = StringToInt(NewValue) == 1;
	else if (!strcmp(CvarName, "tod_dmg_playeronly", false)) g_bDmgPlayerOnly = StringToInt(NewValue) == 1;
	else mp_friendlyfire_on = StringToInt(NewValue) != 0;
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client);
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	if (!CURRENT_ACCESS && bCallAfterAdminAction) VIP_ShowMenu(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	SDKUnhook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	if ((g_bAccess[client] = enabled)) SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public Action:OnTakeDamage(client, &attacker, &inflictor, &Float:damage, &damagetype)
{
	if (g_bAccess[client] && !g_bUsed[client] && damage >= float(GetEntProp(client, Prop_Send, "m_iHealth")) && !WeaponFight_IsDuel())
	{
		if (damagetype == /*64*/DMG_BLAST && inflictor > MaxClients) // c4 explode
		{
			decl String:class[32];
			if (GetEntityClassname(inflictor, class, sizeof(class)) && !strcmp(class, "planted_c4", false))
				return Plugin_Continue;
		}
	
		if (g_bDmgPlayerOnly && (attacker < 1 || attacker > MaxClients))
			return Plugin_Continue;

		if (client == attacker && !g_bDmgSelf)
			return Plugin_Continue;
		
		if (!mp_friendlyfire_on && client != attacker && GetClientTeam(attacker) == GetClientTeam(client)) // bug fix?
			return Plugin_Continue;
		
		g_bUsed[client] = true;
		SetEntProp(client, Prop_Send, "m_iHealth", 1);
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public player_spawn(Handle:event, const String:name[], bool:silent) g_bUsed[GetClientOfUserId(GetEventInt(event, "userid"))] = false;
public OnClientDisconnect_Post(client) g_bAccess[client] = false;